"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeDefaultOptions = exports.makeOptions = void 0;
var getDefaultModelName_1 = require("../utils/getDefaultModelName");
var makeOptions = function (app, options) {
    if (!app) {
        throw new Error("feathers-casl: You need to provide an 'app' to the channels:makeOptions function");
    }
    options = options || {};
    var caslOptions = app.get("casl");
    var appOptions = (caslOptions === null || caslOptions === void 0 ? void 0 : caslOptions.channels) || exports.makeDefaultOptions();
    return Object.assign(appOptions, options);
};
exports.makeOptions = makeOptions;
var defaultOptions = {
    activated: true,
    channelOnError: ["authenticated"],
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    ability: (function (app, connection, data, context) {
        return connection.ability;
    }),
    modelName: getDefaultModelName_1.getContextPath,
    restrictFields: true
};
var makeDefaultOptions = function (options) {
    return Object.assign({}, defaultOptions, options || {});
};
exports.makeDefaultOptions = makeDefaultOptions;
