"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var errors_1 = require("@feathersjs/errors");
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var pick_1 = __importDefault(require("lodash/pick"));
var ability_1 = require("@casl/ability");
var feathers_utils_1 = require("feathers-utils");
var getModelName_1 = __importDefault(require("../../utils/getModelName"));
var getQueryFor_1 = __importDefault(require("../../utils/getQueryFor"));
var hasRestrictingFields_1 = __importDefault(require("../../utils/hasRestrictingFields"));
var hasRestrictingConditions_1 = __importDefault(require("../../utils/hasRestrictingConditions"));
var authorize_hook_utils_1 = require("./authorize.hook.utils");
var HOOKNAME = "authorize";
exports.default = (function (options) {
    return function (context) { return __awaiter(void 0, void 0, void 0, function () {
        var service, method, id, params, modelName, ability, queryGet, paramsGet, item, fields, data, itemPlain, options_1, query, data, i;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    //TODO: make as isomorphic hook -> for vue-client
                    if (feathers_utils_1.shouldSkip(HOOKNAME, context) ||
                        context.type !== "before" ||
                        !context.params) {
                        return [2 /*return*/, context];
                    }
                    service = context.service, method = context.method, id = context.id, params = context.params;
                    options = authorize_hook_utils_1.makeOptions(context.app, options);
                    modelName = getModelName_1.default(options.modelName, context);
                    if (!modelName) {
                        return [2 /*return*/, context];
                    }
                    return [4 /*yield*/, authorize_hook_utils_1.getAbility(context, options)];
                case 1:
                    ability = _b.sent();
                    if (!ability) {
                        // Ignore internal or not authenticated requests
                        return [2 /*return*/, context];
                    }
                    if (options.checkMultiActions) {
                        authorize_hook_utils_1.checkMulti(context, ability, modelName, options.actionOnForbidden);
                    }
                    authorize_hook_utils_1.throwUnlessCan(ability, method, modelName, modelName, options.actionOnForbidden);
                    // if context is with multiple items, there's a change that we need to handle each item separately
                    if (feathers_utils_1.isMulti(context)) {
                        // if has conditions -> hide $select for after-hook, because
                        if (hasRestrictingConditions_1.default(ability, "read", modelName)) {
                            authorize_hook_utils_1.hide$select(context);
                        }
                        else {
                            authorize_hook_utils_1.setPersistedConfig(context, "skipRestrictingRead.conditions", true);
                        }
                        // if has no restricting fields at all -> can skip _pick() in after-hook
                        if (!hasRestrictingFields_1.default(ability, "read", modelName)) {
                            authorize_hook_utils_1.setPersistedConfig(context, "skipRestrictingRead.fields", true);
                        }
                    }
                    if (!(["get", "patch", "update", "remove"].includes(method) && id != null)) return [3 /*break*/, 6];
                    queryGet = Object.assign({}, params.query || {});
                    delete queryGet.$select;
                    paramsGet = Object.assign({}, params, { query: queryGet });
                    paramsGet.skipHooks = ((_a = params.skipHooks) === null || _a === void 0 ? void 0 : _a.slice()) || [];
                    feathers_utils_1.pushSet(paramsGet, "skipHooks", "" + HOOKNAME, { unique: true });
                    return [4 /*yield*/, service.get(id, paramsGet)];
                case 2:
                    item = _b.sent();
                    authorize_hook_utils_1.throwUnlessCan(ability, method, ability_1.subject(modelName, item), modelName, options.actionOnForbidden);
                    if (method === "get") {
                        context.result = item;
                        //pushSet(context, "params.skipHooks", "after");
                        return [2 /*return*/, context];
                    }
                    if (!["update", "patch"].includes(method)) return [3 /*break*/, 5];
                    fields = hasRestrictingFields_1.default(ability, method, ability_1.subject(modelName, item));
                    if (!fields) {
                        return [2 /*return*/, context];
                    }
                    data = pick_1.default(context.data, fields);
                    // if fields are not overlapping -> throw
                    if (isEmpty_1.default(data)) {
                        if (options.actionOnForbidden) {
                            options.actionOnForbidden();
                        }
                        throw new errors_1.Forbidden("You're not allowed to make this request");
                    }
                    if (!(method === "patch")) return [3 /*break*/, 3];
                    context.data = data;
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, service._get(id)];
                case 4:
                    itemPlain = _b.sent();
                    context.data = Object.assign({}, itemPlain, data);
                    _b.label = 5;
                case 5: return [2 /*return*/, context];
                case 6:
                    if (method === "find" || (["patch", "remove"].includes(method) && id == null)) {
                        // multi: find | patch | remove
                        if (hasRestrictingConditions_1.default(ability, method, modelName)) {
                            options_1 = {
                                skipFields: method === "find"
                            };
                            query = getQueryFor_1.default(ability, method, modelName, options_1);
                            if (!isEmpty_1.default(query)) {
                                if (!context.params.query) {
                                    context.params.query = query;
                                }
                                else {
                                    context.params.query = feathers_utils_1.mergeQuery(context.params.query, query, { defaultHandle: "intersect" });
                                }
                            }
                        }
                        return [2 /*return*/, context];
                    }
                    else if (method === "create") {
                        data = (Array.isArray(context.data)) ? context.data : [context.data];
                        for (i = 0; i < data.length; i++) {
                            authorize_hook_utils_1.throwUnlessCan(ability, method, ability_1.subject(modelName, data[i]), modelName, options.actionOnForbidden);
                        }
                        return [2 /*return*/, context];
                    }
                    _b.label = 7;
                case 7: return [2 /*return*/, context];
            }
        });
    }); };
});
